



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>洛谷 P3711 仓鼠的数学题 [伯努利数 fft]</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">洛谷 P3711 仓鼠的数学题 [伯努利数 fft]</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 23:00:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1><a href="https://www.luogu.org/problem/show?pid=3711" rel="external nofollow noreferrer">P3711 仓鼠的数学题</a></h1>
<p>题意：</p>
<p><div>\[S_m(x) = \sum_{k=0}^x k^m, 0^0=1\quad 求 \sum_{m=0}^n S_m(x)a_m<br />
\]</div></p>
<p>的答案多项式\(\sum_{i=0}^{n+1}c_ix^i\)各项系数</p>
<hr>
<p>一开始用了\(B^-\)，然后后面要展开\((x+1)^k\)，完全不会做</p>
<p>和出题人fjzzq2002讨论了一下，原来标程用的是\(B^+\)，不需要展开了</p>
<p>那就很简单了...不想写过程了，最后的结果就是</p>
<p><div>\[C_t = \frac{1}{t!} \sum_{m=0}^{n+t} f_m h_{m+1-t} \\<br />
f(x) = \sum_{i=0}^n a_i i!,\ g(x) = \sum_{i=0}^n \frac{B_i^+}{i!},\ h_i = g_{n+1-i}<br />
\]</div></p>
<p>然后我发现用\(B^+\)好像没有常数项啊？但是用\(B^-\)写暴力计算确实有常数项</p>
<p>然后发现常数项就是\(a_0\)，交上就过了...</p>
<p></br></p>
<p>update:去问了张队长，然后意识到，\(B^+\)算的和是从1开始...然后常数项就是\(a_0 0^0 = a_0\)</p>
<pre class="prettyprint linenums"><code>#include &lt;iostream&gt;<br />
#include &lt;cstdio&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;cmath&gt;<br />
using namespace std;<br />
typedef long long ll;<br />
const int N = (1&lt;&lt;20) + 5, P = 998244353, mo = P, inv2 = (P+1)/2;<br />
const double PI = acos(-1.0);<br />
inline int read(){<br />
    char c=getchar(); int x=0,f=1;<br />
    while(c&lt;'0'||c&gt;'9') {if(c=='-')f=-1;c=getchar();}<br />
    while(c&gt;='0'&amp;&amp;c&lt;='9') {x=x*10+c-'0';c=getchar();}<br />
    return x*f;<br />
}

inline int Pow(ll a, int b) {<br />
	ll ans = 1;<br />
	for(; b; b&gt;&gt;=1, a=a*a%P)<br />
		if(b&amp;1) ans=ans*a%P;<br />
	return ans;<br />
}<br />
namespace fft {<br />
	int rev[N], g = 3;<br />
	void dft(int *a, int n, int flag) {<br />
		int k = 0; while((1&lt;&lt;k) &lt; n) k++;<br />
		for(int i=0; i&lt;n; i++) {<br />
			rev[i] = (rev[i&gt;&gt;1]&gt;&gt;1) | ((i&amp;1)&lt;&lt;(k-1));<br />
			if(i &lt; rev[i]) swap(a[i], a[rev[i]]);<br />
		}<br />
		for(int l=2; l&lt;=n; l&lt;&lt;=1) {<br />
			int m = l&gt;&gt;1, wn = Pow(g, flag==1 ? (P-1)/l : P-1-(P-1)/l);<br />
			for(int *p = a; p != a+n; p += l)<br />
				for(int k=0, w=1; k&lt;m; k++, w = (ll)w*wn %P) {<br />
					int t = (ll) p[k+m] * w %P;<br />
					p[k+m] = (p[k] - t + P) %P;<br />
					p[k] = (p[k] + t) %P;<br />
				}<br />
		}<br />
		if(flag == -1) {<br />
			ll inv = Pow(n, P-2);<br />
			for(int i=0; i&lt;n; i++) a[i] = a[i] * inv %P;<br />
		}<br />
	}

	int t[N];<br />
	void inverse(int *a, int *b, int l) {<br />
		if(l == 1) {b[0] = Pow(a[0], P-2); return;}<br />
		inverse(a, b, l&gt;&gt;1);<br />
		int n = l&lt;&lt;1;<br />
		for(int i=0; i&lt;l; i++) t[i] = a[i], t[i+l] = 0;<br />
		dft(t, n, 1); dft(b, n, 1);<br />
		for(int i=0; i&lt;n; i++) b[i] = (ll) b[i] * (2 - (ll) b[i] * t[i] %P + P) %P;<br />
		dft(b, n, -1); for(int i=l; i&lt;n; i++) b[i] = 0;<br />
	}

	void mul(int *a, int *b, int n) {<br />
		dft(a, n, 1); dft(b, n, 1);<br />
		for(int i=0; i&lt;n; i++) a[i] = (ll) a[i] * b[i] %P;<br />
		dft(a, n, -1);<br />
	}<br />
}

int n, a[N], len;<br />
ll inv[N], fac[N], facInv[N];<br />
int q[N], b[N], f[N], g[N];<br />
int main() {<br />
	freopen(&quot;in&quot;, &quot;r&quot;, stdin);<br />
	n=read();<br />
	for(int i=0; i&lt;=n; i++) a[i] = read();

	inv[1] = fac[0] = facInv[0] = 1;<br />
	for(int i=1; i&lt;=n+2; i++) {<br />
		if(i != 1) inv[i] = (P - P/i) * inv[P%i] %P;<br />
		fac[i] = fac[i-1] * i %P;<br />
		facInv[i] = facInv[i-1] * inv[i] %P;<br />
	}

	len = 1; while(len &lt;= n+1) len &lt;&lt;= 1;<br />
	for(int i=0; i&lt;=n+1; i++) q[i] = facInv[i+1];<br />
	fft::inverse(q, b, len);<br />
	for(int i=0; i&lt;=n+1; i++) b[i] = b[i] * fac[i] %P;<br />
	b[1] = inv2;

	for(int i=0; i&lt;=n; i++) f[i] = (ll) a[i] * fac[i] %P;<br />
	for(int i=0; i&lt;=n; i++) g[n+1-i] = (ll) b[i] * facInv[i] %P;<br />
	while(len &lt;= n+n+1) len &lt;&lt;= 1;<br />
	fft::mul(f, g, len);<br />
	printf(&quot;%d &quot;, a[0]);<br />
	for(int i=1; i&lt;=n+1; i++) printf(&quot;%lld &quot;, f[n+i] * facInv[i] %P);<br />
}

</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96mnp38.html">在Jenkins中获取GitHub对应Repository的Resource Code</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq474yjq.html">ArcGIS Server 10 Java 版的Rest服务手动配置方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q70egk8.html">C&num;对称加密（AES加密）每次生成的密文结果不同思路代码分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq42vme9.html">C&plus;&plus;构造函数初始化顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96nzovq.html">angularJS支持的事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8elelzq.html">LTE Module User Documentation（翻译7）&mdash;&mdash;无线环境地图（REM）、AMC 模型 和 CQI 计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy71xgq.html">archlinux 内核编译笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v750j8.html">The shortest problem</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnnepoq.html">python内置函数的归集</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mynjeq.html">贪心&lpar;数据结构&rpar;：COGS 468&period; &lbrack;NOI2010&rsqb;超级钢琴</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wlv4oq.html">java 获取黑屏信息保存在list中，截取字符执行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydkylgq.html">转&colon; Python 运算符与用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1o0v2q.html">【二十六】php之文件编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zolmv1q.html">ionic2 安装（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdzo0y9.html">HTML5商城开发五 实现返回页面顶部</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z4pme9.html">迭代DOM集合的几种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyydp12q.html">Mysql字符串切分</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gwlveq.html">Eclipse和MyEclipse使用技巧--解决MyEclipse中的js报错的小方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvgd3x8.html">java九九乘法表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll7weeq.html">先埋锅-CF-Valid BFS&quest;-差一点没交上</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwjxogk8.html">SPI、I2C、UART（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zwnzj9.html">&lbrack;国嵌笔记&rsqb;&lbrack;026&rsqb;&lbrack;ARM伪指令&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1n02zq.html">Winform &amp;amp&semi; Devexpress Chart使用入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z3gpg9.html">BC高精确度函数使用。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1nk6xq.html">TP5 中实现支付宝支付  利用model层调用支付宝类库</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zox66nq.html">JAR包介绍大全用途作用详解JAVA</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zox6n1q.html">Android-第三天</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jvyg38.html">CCF系列之模板生成系统&lpar; 201509-3 &rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdeep49.html">mysql-innoDB-锁</a>
			</li>
						<li><a href="https://www.batexi.com/a/950yyy68.html">通过Azure 存储账号URL鉴别是标准磁盘还是高性能磁盘</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
